-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04522 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04522;

-- Delete any existing global settings.
delete from USER_SETTINGS
  where USER_ID is null;

-- Remove nullability from user settings.
alter table USER_SETTINGS
  modify (USER_ID constraint NOT_NULL_US_USER_ID not null);

-- New table for global settings.
create table GLOBAL_SETTINGS (
  GLOBAL_SETTING_ID number constraint NOT_NULL_GLOBAL_SETTING_ID not null,
  OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_GS_OPT_LOCK_VER not null,
  ATTR varchar2(255) constraint NOT_NULL_GS_ATTR not null,
  VALUE clob constraint NOT_NULL_GS_VALUE not null,
  constraint PK_GLOBAL_SETTINGS primary key (GLOBAL_SETTING_ID)
);

-- Attribute must be unique.
create unique index IDX_UNIQUE_GLOBAL_SETTING on GLOBAL_SETTINGS
  (ATTR);
